Index: /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java
===================================================================
--- /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 53)
+++ /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 1)
@@ -3,62 +3,35 @@
 import java.io.IOException;
 import java.math.BigInteger;
+import java.net.URI;
+import java.net.URISyntaxException;
 import java.util.Arrays;
-import java.util.Collections;
 import java.util.HashSet;
-import java.util.List;
 import java.util.Random;
-import java.util.Set;
 import java.util.logging.Level;
-import java.util.stream.Collectors;
 
 import geniusweb.actions.Accept;
 import geniusweb.actions.Action;
-import geniusweb.actions.LearningDone;
 import geniusweb.actions.Offer;
 import geniusweb.actions.PartyId;
-import geniusweb.actions.Vote;
-import geniusweb.actions.VoteWithValue;
-import geniusweb.actions.Votes;
-import geniusweb.actions.VotesWithValue;
 import geniusweb.bidspace.AllPartialBidsList;
-import geniusweb.inform.ActionDone;
-import geniusweb.inform.Finished;
-import geniusweb.inform.Inform;
-import geniusweb.inform.OptIn;
-import geniusweb.inform.OptInWithValue;
-import geniusweb.inform.Settings;
-import geniusweb.inform.Voting;
-import geniusweb.inform.YourTurn;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
 import geniusweb.party.DefaultParty;
-import geniusweb.profile.PartialOrdering;
-import geniusweb.profile.Profile;
-import geniusweb.profile.utilityspace.UtilitySpace;
+import geniusweb.party.inform.ActionDone;
+import geniusweb.party.inform.Finished;
+import geniusweb.party.inform.Inform;
+import geniusweb.party.inform.Settings;
+import geniusweb.party.inform.YourTurn;
+import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
 import geniusweb.profileconnection.ProfileConnectionFactory;
 import geniusweb.profileconnection.ProfileInterface;
 import geniusweb.progress.Progress;
 import geniusweb.progress.ProgressRounds;
+import geniusweb.references.ProtocolRef;
 import tudelft.utilities.logging.Reporter;
 
 /**
- * A party that places random bids and accepts when it receives an offer with
- * sufficient utility. This party is also a demo on how to support the various
- * protocols, which causes this party to look a bit complex.
- * 
- * <h2>parameters</h2>
- * <table >
- * <caption>parameters</caption>
- * <tr>
- * <td>minPower</td>
- * <td>This value is used as minPower for placed {@link Vote}s. Default value is
- * 2.</td>
- * </tr>
- * <tr>
- * <td>maxPower</td>
- * <td>This value is used as maxPower for placed {@link Vote}s. Default value is
- * infinity.</td>
- * </tr>
- * </table>
+ * A simple party that places random bids and accepts when it receives an offer
+ * with sufficient utility.
  */
 public class RandomParty extends DefaultParty {
@@ -67,10 +40,6 @@
 	private PartyId me;
 	private final Random random = new Random();
-	protected ProfileInterface profileint = null;
+	protected ProfileInterface profileint;
 	private Progress progress;
-	private Settings settings;
-	private Votes lastvotes;
-	private VotesWithValue lastvoteswithvalue;
-	private String protocol;
 
 	public RandomParty() {
@@ -85,15 +54,9 @@
 		try {
 			if (info instanceof Settings) {
-				Settings sett = (Settings) info;
-				this.me = sett.getID();
-				this.progress = sett.getProgress();
-				this.settings = sett;
-				this.protocol = sett.getProtocol().getURI().getPath();
-				if ("Learn".equals(protocol)) {
-					getConnection().send(new LearningDone(me));
-				} else {
-					this.profileint = ProfileConnectionFactory
-							.create(sett.getProfile().getURI(), getReporter());
-				}
+				Settings settings = (Settings) info;
+				this.profileint = ProfileConnectionFactory
+						.create(settings.getProfile().getURI(), getReporter());
+				this.me = settings.getID();
+				this.progress = settings.getProgress();
 			} else if (info instanceof ActionDone) {
 				Action otheract = ((ActionDone) info).getAction();
@@ -102,94 +65,36 @@
 				}
 			} else if (info instanceof YourTurn) {
-				makeOffer();
+				myTurn();
+				if (progress instanceof ProgressRounds) {
+					progress = ((ProgressRounds) progress).advance();
+				}
 			} else if (info instanceof Finished) {
 				getReporter().log(Level.INFO, "Final ourcome:" + info);
-				terminate(); // stop this party and free resources.
-			} else if (info instanceof Voting) {
-				switch (protocol) {
-				case "MOPAC":
-					lastvotes = vote((Voting) info);
-					getConnection().send(lastvotes);
-					break;
-				case "MOPAC2":
-					lastvoteswithvalue = voteWithValue((Voting) info);
-					getConnection().send(lastvoteswithvalue);
-				}
-			} else if (info instanceof OptIn) {
-				// just repeat our last vote.
-				getConnection().send(lastvotes);
-			} else if (info instanceof OptInWithValue) {
-				getConnection().send(lastvoteswithvalue);
 			}
 		} catch (Exception e) {
-			throw new RuntimeException("Failed to handle info", e);
+			getReporter().log(Level.SEVERE, "Failed to handle info", e);
 		}
-		updateRound(info);
 	}
 
 	@Override
 	public Capabilities getCapabilities() {
-		return new Capabilities(new HashSet<>(
-				Arrays.asList("SAOP", "AMOP", "MOPAC", "MOPAC2", "Learn")),
-				Collections.singleton(Profile.class));
+		try {
+			return new Capabilities(new HashSet<>(
+					Arrays.asList(new ProtocolRef(new URI("SAOP")))));
+		} catch (URISyntaxException e) {
+			getReporter().log(Level.SEVERE, "Failed to create capabilities URI",
+					e);
+			return null;
+		}
 	}
 
 	@Override
 	public String getDescription() {
-		return "places random bids until it can accept an offer with utility >0.6. "
-				+ "Parameters minPower and maxPower can be used to control voting behaviour.";
+		return "places random bids until it can accept an offer with utility >0.6";
 	}
 
-	@Override
-	public void terminate() {
-		super.terminate();
-		if (this.profileint != null) {
-			this.profileint.close();
-			this.profileint = null;
-		}
-	}
-
-	/******************* private support funcs ************************/
-
-	/**
-	 * Update {@link #progress}
-	 * 
-	 * @param info the received info. Used to determine if this is the last info
-	 *             of the round
-	 */
-	private void updateRound(Inform info) {
-		if (protocol == null)
-			return;
-		switch (protocol) {
-		case "SAOP":
-		case "SHAOP":
-			if (!(info instanceof YourTurn))
-				return;
-			break;
-		case "MOPAC":
-			if (!(info instanceof OptIn))
-				return;
-			break;
-		case "MOPAC2":
-			if (!(info instanceof OptInWithValue))
-				return;
-			break;
-		default:
-			return;
-		}
-		// if we get here, round must be increased.
-		if (progress instanceof ProgressRounds) {
-			progress = ((ProgressRounds) progress).advance();
-		}
-
-	}
-
-	/**
-	 * send our next offer
-	 */
-	private void makeOffer() throws IOException {
+	private void myTurn() throws IOException {
 		Action action;
-		if ((protocol.equals("SAOP") || protocol.equals("SHAOP"))
-				&& isGood(lastReceivedBid)) {
+		if (isGood(lastReceivedBid)) {
 			action = new Accept(me, lastReceivedBid);
 		} else {
@@ -208,74 +113,8 @@
 	}
 
-	/**
-	 * @param bid the bid to check
-	 * @return true iff bid is good for us.
-	 */
 	private boolean isGood(Bid bid) {
-		if (bid == null)
-			return false;
-		Profile profile;
-		try {
-			profile = profileint.getProfile();
-		} catch (IOException e) {
-			throw new IllegalStateException(e);
-		}
-		if (profile instanceof UtilitySpace)
-			return ((UtilitySpace) profile).getUtility(bid).doubleValue() > 0.6;
-		if (profile instanceof PartialOrdering) {
-			return ((PartialOrdering) profile).isPreferredOrEqual(bid,
-					profile.getReservationBid());
-		}
-		return false;
-	}
-
-	/**
-	 * @param voting the {@link Voting} object containing the options
-	 * 
-	 * @return our next Votes.
-	 */
-	private Votes vote(Voting voting) throws IOException {
-		Object val = settings.getParameters().get("minPower");
-		Integer minpower = (val instanceof Integer) ? (Integer) val : 2;
-		val = settings.getParameters().get("maxPower");
-		Integer maxpower = (val instanceof Integer) ? (Integer) val
-				: Integer.MAX_VALUE;
-
-		Set<Vote> votes = voting.getOffers().stream().distinct()
-				.filter(offer -> isGood(offer.getBid()))
-				.map(offer -> new Vote(me, offer.getBid(), minpower, maxpower))
-				.collect(Collectors.toSet());
-		return new Votes(me, votes);
-	}
-
-	/**
-	 * @param voting the {@link Voting} object containing the options
-	 * 
-	 * @return our next Votes. Returns only votes on good bids and tries to
-	 *         distribute vote values evenly over all good bids.
-	 */
-	private VotesWithValue voteWithValue(Voting voting) throws IOException {
-		Object val = settings.getParameters().get("minPower");
-		Integer minpower = (val instanceof Integer) ? (Integer) val : 2;
-		val = settings.getParameters().get("maxPower");
-		Integer maxpower = (val instanceof Integer) ? (Integer) val
-				: Integer.MAX_VALUE;
-
-		List<Bid> goodbids = voting.getOffers().stream().distinct()
-				.filter(offer -> isGood(offer.getBid()))
-				.map(offer -> offer.getBid()).collect(Collectors.toList());
-
-		if (goodbids.isEmpty()) {
-			return new VotesWithValue(me, Collections.emptySet());
-		}
-		// extra difficulty now is to have the utility sum to exactly 100
-		int mostvalues = 100 / goodbids.size();
-		int value = 100 - mostvalues * (goodbids.size() - 1);
-		Set<VoteWithValue> votes = new HashSet<>();
-		for (Bid bid : goodbids) {
-			votes.add(new VoteWithValue(me, bid, minpower, maxpower, value));
-			value = mostvalues;
-		}
-		return new VotesWithValue(me, votes);
+		return bid != null
+				&& ((LinearAdditiveUtilitySpace) profileint.getProfile())
+						.getUtility(bid).doubleValue() > 0.6;
 	}
 
Index: /exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java
===================================================================
--- /exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java	(revision 53)
+++ /exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java	(revision 1)
@@ -7,7 +7,5 @@
 import static org.mockito.Matchers.eq;
 import static org.mockito.Mockito.mock;
-import static org.mockito.Mockito.times;
 import static org.mockito.Mockito.verify;
-import static org.mockito.Mockito.when;
 
 import java.io.IOException;
@@ -18,6 +16,4 @@
 import java.nio.file.Files;
 import java.nio.file.Paths;
-import java.util.Arrays;
-import java.util.Collections;
 import java.util.LinkedList;
 import java.util.List;
@@ -36,22 +32,16 @@
 import geniusweb.actions.Offer;
 import geniusweb.actions.PartyId;
-import geniusweb.actions.Votes;
-import geniusweb.actions.VotesWithValue;
 import geniusweb.bidspace.AllBidsList;
-import geniusweb.connection.ConnectionEnd;
-import geniusweb.inform.ActionDone;
-import geniusweb.inform.Agreements;
-import geniusweb.inform.Finished;
-import geniusweb.inform.Inform;
-import geniusweb.inform.OptIn;
-import geniusweb.inform.Settings;
-import geniusweb.inform.Voting;
-import geniusweb.inform.YourTurn;
+import geniusweb.connection.Connection;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
+import geniusweb.party.inform.ActionDone;
+import geniusweb.party.inform.Finished;
+import geniusweb.party.inform.Inform;
+import geniusweb.party.inform.Settings;
+import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
-import geniusweb.profile.utilityspace.LinearAdditive;
+import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
 import geniusweb.progress.ProgressRounds;
-import geniusweb.references.Parameters;
 import geniusweb.references.ProfileRef;
 import geniusweb.references.ProtocolRef;
@@ -62,6 +52,5 @@
 public class RandomPartyTest {
 
-	private static final PartyId PARTY1 = new PartyId("party1");
-	private static final String SAOP = "SAOP";
+	private static final ProtocolRef SAOP = new ProtocolRef("SAOP");
 	private static final PartyId otherparty = new PartyId("other");
 	private static final String PROFILE = "src/test/resources/testprofile.json";
@@ -69,12 +58,9 @@
 
 	private RandomParty party;
-	private final TestConnection connection = new TestConnection();
-	private final ProtocolRef protocol = new ProtocolRef(SAOP);
-	private final ProtocolRef mopacProtocol = new ProtocolRef("MOPAC");
-	private final ProtocolRef mopac2Protocol = new ProtocolRef("MOPAC2");
-	private final ProgressRounds progress = mock(ProgressRounds.class);
-	private Settings settings, mopacSettings, mopac2Settings;
-	private LinearAdditive profile;
-	private final Parameters parameters = new Parameters();
+	private TestConnection connection = new TestConnection();
+	private ProtocolRef protocol = mock(ProtocolRef.class);
+	private ProgressRounds progress = mock(ProgressRounds.class);
+	private Settings settings;
+	private LinearAdditiveUtilitySpace profile;
 
 	@Before
@@ -82,17 +68,11 @@
 			IOException, URISyntaxException {
 		party = new RandomParty();
-		settings = new Settings(PARTY1,
-				new ProfileRef(new URI("file:" + PROFILE)), protocol, progress,
-				parameters);
-		mopacSettings = new Settings(PARTY1,
-				new ProfileRef(new URI("file:" + PROFILE)), mopacProtocol,
-				progress, parameters);
-		mopac2Settings = new Settings(PARTY1,
-				new ProfileRef(new URI("file:" + PROFILE)), mopac2Protocol,
-				progress, parameters);
+		settings = new Settings(new PartyId("party1"),
+				new ProfileRef(new URI("file:" + PROFILE)), protocol, progress);
 
 		String serialized = new String(Files.readAllBytes(Paths.get(PROFILE)),
 				StandardCharsets.UTF_8);
-		profile = (LinearAdditive) jackson.readValue(serialized, Profile.class);
+		profile = (LinearAdditiveUtilitySpace) jackson.readValue(serialized,
+				Profile.class);
 
 	}
@@ -111,5 +91,5 @@
 		Capabilities capabilities = party.getCapabilities();
 		assertFalse("party does not define protocols",
-				capabilities.getBehaviours().isEmpty());
+				capabilities.getProtocols().isEmpty());
 	}
 
@@ -124,5 +104,5 @@
 	public void testInformSettings() {
 		party.connect(connection);
-		connection.notifyListeners(settings);
+		connection.notifyChange(settings);
 		assertEquals(0, connection.getActions().size());
 	}
@@ -176,14 +156,12 @@
 		party.connect(connection);
 		party.notifyChange(settings);
-		Agreements agreements = mock(Agreements.class);
-		when(agreements.toString()).thenReturn("agree");
-		party.notifyChange(new Finished(agreements));
+		party.notifyChange(new Finished(null));
 
 		verify(reporter).log(eq(Level.INFO),
-				eq("Final ourcome:Finished[agree]"));
-	}
-
-	@Test
-	public void testAgentsUpdatesSAOPProgress() {
+				eq("Final ourcome:Finished[null]"));
+	}
+
+	@Test
+	public void testAgentsUpdatesProgress() {
 		party.connect(connection);
 		party.notifyChange(settings);
@@ -194,20 +172,6 @@
 
 	@Test
-	public void testAgentsUpdatesMOPACProgress() {
-		party.connect(connection);
-		party.notifyChange(mopacSettings);
-		// in mopac, progress happens only after optin phase
-		party.notifyChange(new YourTurn());
-		verify(progress, times(0)).advance();
-		party.notifyChange(
-				new Voting(Collections.emptyList(), Collections.emptyMap()));
-		verify(progress, times(0)).advance();
-		party.notifyChange(new OptIn(Collections.emptyList()));
-		verify(progress, times(1)).advance();
-	}
-
-	@Test
 	public void testGetCapabilities() {
-		assertTrue(party.getCapabilities().getBehaviours().contains(SAOP));
+		assertTrue(party.getCapabilities().getProtocols().contains(SAOP));
 	}
 
@@ -223,37 +187,4 @@
 	}
 
-	@Test
-	public void testVoting() throws URISyntaxException {
-		party.connect(connection);
-		party.notifyChange(mopacSettings);
-
-		Bid bid = findGoodBid();
-		Offer offer = new Offer(PARTY1, bid);
-		party.notifyChange(new Voting(Arrays.asList(offer),
-				Collections.singletonMap(PARTY1, 1)));
-		assertEquals(1, connection.getActions().size());
-		Action action = connection.getActions().get(0);
-		assertTrue(action instanceof Votes);
-		assertEquals(1, ((Votes) action).getVotes().size());
-		assertEquals(bid,
-				((Votes) action).getVotes().iterator().next().getBid());
-	}
-
-	@Test
-	public void testVotingWithValue() throws URISyntaxException {
-		party.connect(connection);
-		party.notifyChange(mopac2Settings);
-
-		Bid bid = findGoodBid();
-		Offer offer = new Offer(PARTY1, bid);
-		party.notifyChange(new Voting(Arrays.asList(offer),
-				Collections.singletonMap(PARTY1, 1)));
-		assertEquals(1, connection.getActions().size());
-		Action action = connection.getActions().get(0);
-		assertTrue(action instanceof VotesWithValue);
-		assertEquals(1, ((VotesWithValue) action).getVotes().size());
-		assertEquals(bid, ((VotesWithValue) action).getVotes().iterator().next()
-				.getBid());
-	}
 }
 
@@ -265,5 +196,5 @@
  */
 class TestConnection extends DefaultListenable<Inform>
-		implements ConnectionEnd<Inform, Action> {
+		implements Connection<Inform, Action> {
 	private List<Action> actions = new LinkedList<>();
 
Index: /exampleparties/randompartypy/bin/.pydevproject
===================================================================
--- /exampleparties/randompartypy/bin/.pydevproject	(revision 1)
+++ /exampleparties/randompartypy/bin/.pydevproject	(revision 1)
@@ -0,0 +1,5 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<?eclipse-pydev version="1.0"?><pydev_project>
+<pydev_property name="org.python.pydev.PYTHON_PROJECT_INTERPRETER">Default</pydev_property>
+<pydev_property name="org.python.pydev.PYTHON_PROJECT_VERSION">python interpreter</pydev_property>
+</pydev_project>
Index: /exampleparties/randompartypy/bin/src/main/resources/RandomParty.py
===================================================================
--- /exampleparties/randompartypy/bin/src/main/resources/RandomParty.py	(revision 1)
+++ /exampleparties/randompartypy/bin/src/main/resources/RandomParty.py	(revision 1)
@@ -0,0 +1,94 @@
+import time
+import traceback
+
+import geniusweb.party.inform.ActionDone as ActionDone
+import geniusweb.party.inform.Inform as Inform
+import geniusweb.party.inform.Settings as Settings
+import geniusweb.party.inform.YourTurn as YourTurn
+
+
+import java.math.BigInteger as BigInteger
+import java.net.URI as URI
+import java.util.Arrays as Arrays
+import java.util.HashSet as HashSet
+import java.util.Random as Random
+ 
+import geniusweb.actions.Accept as Accept
+import geniusweb.actions.Action as Action
+import geniusweb.actions.Offer as Offer
+import geniusweb.actions.PartyId as PartyId
+import geniusweb.bidspace.AllPartialBidsList as AllPartialBidsList
+import geniusweb.issuevalue.Bid as Bid
+import geniusweb.party.Capabilities as Capabilities
+import geniusweb.party.DefaultParty as DefaultParty
+import geniusweb.profile.Profile as Profile
+import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace as LinearAdditiveUtilitySpace
+import genius2.references.ProfileRef as ProfileRef
+import genius2.references.ProtocolRef as ProtocolRef
+import geniusweb.profileconnection.ProfileConnectionFactory as ProfileConnectionFactory
+import geniusweb.profileconnection.ProfileInterface as ProfileInterface
+import genius2.progress.ProgressRounds as ProgressRounds
+
+import com.fasterxml.jackson.databind.ObjectMapper as ObjectMapper
+
+class RandomParty (DefaultParty):
+	"""
+	A simple party that places random bids and accepts when it receives an offer
+	with sufficient utility.
+	"""
+
+	jackson = ObjectMapper()
+	random = Random();
+
+	def __init__(self):
+		self.profile = None
+		self.lastReceivedBid = None
+
+	# Override
+	def notifyChange(self, info):
+		if isinstance(info, Settings) :
+			self.profile = ProfileConnectionFactory.create(info.getProfile().getURI(), self.getReporter());
+			self.me = info.getID()
+			self.progress = info.getProgress()
+		elif isinstance(info , ActionDone): 
+			self.lastActor = info.getAction().getActor()
+			otheract = info.getAction()
+			if isinstance(otheract, Offer):
+				self.lastReceivedBid = otheract.getBid()
+		elif isinstance(info , YourTurn):
+			self._myTurn()
+			if isinstance(self.progress, ProgressRounds) :
+				self.progress = self.progress.advance();
+
+	# Override
+	def getCapabilities(self): # -> Capabilities
+		try:
+			return Capabilities(HashSet([ ProtocolRef(URI("SAOP"))]))
+		except:
+			getReporter().log(Level.SEVERE, "Failed to create capabilities URI",e);
+		return None
+
+	# Override
+	def getDescription(self):
+		return "places random bids until it can accept an offer with utility >0.6. Python version"
+
+	def _myTurn(self):
+		if self.lastReceivedBid != None and self.profile.getProfile().getUtility(self.lastReceivedBid).doubleValue() > 0.6:
+			action = Accept(self.me, self.lastReceivedBid)
+		else:
+			bidspace = AllPartialBidsList(self.profile.getProfile().getDomain())
+			bid = None
+			for attempt in range(20):
+				i = self.random.nextInt(bidspace.size()) # warning: jython implicitly converts BigInteger to long.
+				bid = bidspace.get(BigInteger.valueOf(i))
+				if self._isGood(bid):
+					break
+			action = Offer(self.me, bid);
+		try:
+			self.getConnection().send(action)
+		except:
+			print 'failed to send action '+action.toString()
+			traceback.print_exc()
+
+	def _isGood(self, bid):
+		return bid != None and self.profile.getProfile().getUtility(bid).doubleValue() > 0.6;
Index: /exampleparties/randompartypy/src/main/resources/RandomParty.py
===================================================================
--- /exampleparties/randompartypy/src/main/resources/RandomParty.py	(revision 53)
+++ /exampleparties/randompartypy/src/main/resources/RandomParty.py	(revision 1)
@@ -2,9 +2,8 @@
 import traceback
 
-import geniusweb.inform.ActionDone as ActionDone
-import geniusweb.inform.Inform as Inform
-import geniusweb.inform.Settings as Settings
-import geniusweb.inform.YourTurn as YourTurn
-import geniusweb.inform.Finished as Finished
+import geniusweb.party.inform.ActionDone as ActionDone
+import geniusweb.party.inform.Inform as Inform
+import geniusweb.party.inform.Settings as Settings
+import geniusweb.party.inform.YourTurn as YourTurn
 
 
@@ -14,6 +13,4 @@
 import java.util.HashSet as HashSet
 import java.util.Random as Random
-import java.util.Collections as Collections
-import java.util.logging.Level as Level
  
 import geniusweb.actions.Accept as Accept
@@ -26,6 +23,5 @@
 import geniusweb.party.DefaultParty as DefaultParty
 import geniusweb.profile.Profile as Profile
-import geniusweb.profile.PartialOrdering as PartialOrdering
-import geniusweb.profile.utilityspace.UtilitySpace as UtilitySpace
+import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace as LinearAdditiveUtilitySpace
 import geniusweb.references.ProfileRef as ProfileRef
 import geniusweb.references.ProtocolRef as ProtocolRef
@@ -33,5 +29,4 @@
 import geniusweb.profileconnection.ProfileInterface as ProfileInterface
 import geniusweb.progress.ProgressRounds as ProgressRounds
-
 
 import com.fasterxml.jackson.databind.ObjectMapper as ObjectMapper
@@ -65,24 +60,16 @@
 			if isinstance(self.progress, ProgressRounds) :
 				self.progress = self.progress.advance();
-		elif isinstance(info,Finished) :
-			self.getReporter().log(Level.INFO, "Final ourcome:" + info.toString())
-			self.terminate()
-		
 
 	# Override
 	def getCapabilities(self): # -> Capabilities
-			return Capabilities(HashSet([ "SAOP"]), Collections.singleton(Profile));
+		try:
+			return Capabilities(HashSet([ ProtocolRef(URI("SAOP"))]))
+		except:
+			getReporter().log(Level.SEVERE, "Failed to create capabilities URI",e);
+		return None
 
 	# Override
 	def getDescription(self):
 		return "places random bids until it can accept an offer with utility >0.6. Python version"
-
-	# Override
-	def terminate(self):
-		super(RandomParty,self).terminate()
-		if self.profile != None:
-			self.profile.close()
-			self.profile = None
-
 
 	def _myTurn(self):
@@ -105,11 +92,3 @@
 
 	def _isGood(self, bid):
-		if bid == None:
-			return false
-		profile = self.profile.getProfile()
-		if isinstance(profile, UtilitySpace):
-			return profile.getUtility(bid).doubleValue() > 0.6;
-		if isinstance(profile, PartialOrdering):
-			return profile.isPreferredOrEqual(bid, profile.getReservationBid())
-		raise Exception("Can not handle this type of profile")
-
+		return bid != None and self.profile.getProfile().getUtility(bid).doubleValue() > 0.6;
Index: /exampleparties/randompartypy/src/test/java/geniusweb/exampleparties/randompartypy/RandomPartyTest.java
===================================================================
--- /exampleparties/randompartypy/src/test/java/geniusweb/exampleparties/randompartypy/RandomPartyTest.java	(revision 53)
+++ /exampleparties/randompartypy/src/test/java/geniusweb/exampleparties/randompartypy/RandomPartyTest.java	(revision 1)
@@ -31,18 +31,15 @@
 import geniusweb.actions.PartyId;
 import geniusweb.bidspace.AllBidsList;
-import geniusweb.connection.ConnectionEnd;
-import geniusweb.inform.ActionDone;
-import geniusweb.inform.Agreements;
-import geniusweb.inform.Finished;
-import geniusweb.inform.Inform;
-import geniusweb.inform.Settings;
-import geniusweb.inform.YourTurn;
+import geniusweb.connection.Connection;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
+import geniusweb.party.inform.ActionDone;
+import geniusweb.party.inform.Inform;
+import geniusweb.party.inform.Settings;
+import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
-import geniusweb.profile.utilityspace.LinearAdditive;
+import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
 import geniusweb.progress.ProgressRounds;
 import geniusweb.pythonadapter.PythonPartyAdapter;
-import geniusweb.references.Parameters;
 import geniusweb.references.ProfileRef;
 import geniusweb.references.ProtocolRef;
@@ -53,5 +50,5 @@
 
 	private static final String PROFILE = "src/test/resources/testprofile.json";
-	private static final String SAOP = "SAOP";
+	private static final ProtocolRef SAOP = new ProtocolRef("SAOP");
 	private static final PartyId otherparty = new PartyId("other");
 	private final static ObjectMapper jackson = new ObjectMapper();
@@ -59,10 +56,9 @@
 	private PythonPartyAdapter party;
 	private TestConnection connection = new TestConnection();
-	private final ProtocolRef protocol = mock(ProtocolRef.class);
-	private final ProgressRounds progress = mock(ProgressRounds.class);
+	private ProtocolRef protocol = mock(ProtocolRef.class);
+	private ProgressRounds progress = mock(ProgressRounds.class);
 	private Settings settings;
-	private final Parameters parameters = new Parameters();
-
-	private LinearAdditive profile; // the real profile
+
+	private LinearAdditiveUtilitySpace profile; // the real profile
 
 	@Before
@@ -78,9 +74,9 @@
 		};
 		settings = new Settings(new PartyId("party1"),
-				new ProfileRef(new URI("file:" + PROFILE)), protocol, progress,
-				parameters);
+				new ProfileRef(new URI("file:" + PROFILE)), protocol, progress);
 		String serialized = new String(Files.readAllBytes(Paths.get(PROFILE)),
 				StandardCharsets.UTF_8);
-		profile = (LinearAdditive) jackson.readValue(serialized, Profile.class);
+		profile = (LinearAdditiveUtilitySpace) jackson.readValue(serialized,
+				Profile.class);
 
 	}
@@ -99,5 +95,5 @@
 		Capabilities capabilities = party.getCapabilities();
 		assertFalse("party does not define protocols",
-				capabilities.getBehaviours().isEmpty());
+				capabilities.getProtocols().isEmpty());
 	}
 
@@ -112,5 +108,5 @@
 	public void testInformSettings() {
 		party.connect(connection);
-		connection.notifyListeners(settings);
+		connection.notifyChange(settings);
 		assertEquals(0, connection.getActions().size());
 	}
@@ -129,15 +125,4 @@
 
 		party.notifyChange(new ActionDone(new EndNegotiation(otherparty)));
-
-		// party should not act at this point
-		assertEquals(0, connection.getActions().size());
-	}
-
-	@Test
-	public void testFinished() {
-		party.connect(connection);
-		party.notifyChange(settings);
-
-		party.notifyChange(new Finished(new Agreements()));
 
 		// party should not act at this point
@@ -179,5 +164,5 @@
 	@Test
 	public void testGetCapabilities() {
-		assertTrue(party.getCapabilities().getBehaviours().contains(SAOP));
+		assertTrue(party.getCapabilities().getProtocols().contains(SAOP));
 	}
 
@@ -202,5 +187,5 @@
  */
 class TestConnection extends DefaultListenable<Inform>
-		implements ConnectionEnd<Inform, Action> {
+		implements Connection<Inform, Action> {
 	private List<Action> actions = new LinkedList<>();
 
Index: /issuevalue/src/main/java/geniusweb/issuevalue/Bid.java
===================================================================
--- /issuevalue/src/main/java/geniusweb/issuevalue/Bid.java	(revision 53)
+++ /issuevalue/src/main/java/geniusweb/issuevalue/Bid.java	(revision 1)
@@ -3,5 +3,4 @@
 import java.util.Collections;
 import java.util.HashMap;
-import java.util.HashSet;
 import java.util.Map;
 import java.util.Set;
@@ -41,20 +40,5 @@
 
 	/**
-	 * Makes partial bid with just 1 issue and value.
-	 * 
-	 * @param issue the issue name
-	 * @param value the {@link Value}
-	 */
-	public Bid(String issue, Value value) {
-		if (issue == null || value == null) {
-			throw new NullPointerException("issue and value must be not =null");
-		}
-
-		issuevalues = new HashMap<>();
-		issuevalues.put(issue, value);
-	}
-
-	/**
-	 * @param issue name of the issue
+	 * @param issue
 	 * @return the value for the given issue, or null if there is no value for
 	 *         the given issue.
@@ -65,5 +49,6 @@
 
 	/**
-	 * @param issue name of the issue
+	 * 
+	 * @param issue
 	 * @return true iff the bid contains a value for the given issue.
 	 */
@@ -74,33 +59,4 @@
 	public Set<String> getIssues() {
 		return Collections.unmodifiableSet(issuevalues.keySet());
-	}
-
-	/**
-	 * Merges this partial bid with another partial bid.
-	 * 
-	 * @param otherbid another partial bid.
-	 * @return a bid with the combined values of both partial bids.
-	 * @throws IllegalArgumentException if issues overlap.
-	 */
-	public Bid merge(Bid otherbid) {
-		Set<String> ourissues = new HashSet<>(issuevalues.keySet());
-		ourissues.retainAll(otherbid.getIssues());
-		if (!ourissues.isEmpty()) {
-			throw new IllegalArgumentException(
-					"Otherbid contains issues that are already set:"
-							+ ourissues);
-		}
-		HashMap<String, Value> newvalues = new HashMap<>(issuevalues);
-		newvalues.putAll(otherbid.issuevalues);
-		return new Bid(newvalues);
-
-	}
-
-	/**
-	 * 
-	 * @return (unmodifyable) map with all issues and values in the bid.
-	 */
-	public Map<String, Value> getIssueValues() {
-		return Collections.unmodifiableMap(issuevalues);
 	}
 
Index: /issuevalue/src/main/java/geniusweb/issuevalue/DiscreteValueSet.java
===================================================================
--- /issuevalue/src/main/java/geniusweb/issuevalue/DiscreteValueSet.java	(revision 53)
+++ /issuevalue/src/main/java/geniusweb/issuevalue/DiscreteValueSet.java	(revision 1)
@@ -11,4 +11,5 @@
 import com.fasterxml.jackson.annotation.JsonCreator;
 import com.fasterxml.jackson.annotation.JsonProperty;
+import com.fasterxml.jackson.annotation.JsonTypeName;
 import com.fasterxml.jackson.databind.JsonDeserializer;
 import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
@@ -19,4 +20,5 @@
  * set of discrete values
  */
+@JsonTypeName("discreteset")
 // disable the inherited deserializer to prevent getting into infinite loop...
 @JsonDeserialize(using = JsonDeserializer.None.class)
